<?php if (!defined('PmWiki')) exit();

SDV($EnablePDF,false);
SDV($MarkupEnabled['mailform'],0);
if ($EnablePDF) { SDV($PDFCheckboxFmt,
    "<input type='checkbox' name='format' value='makepdf' checked='checked'/>
    <img src='\$FarmPubDirUrl/images/pdficonsmall.gif' align='top' alt='PDF' />");
    SDV($PDFTypesetFmt, " <input type='submit' value='$[Typeset]' />");
    SDV($PDFOptionsFmt, 
    " <input type='submit' name='pdfoptions' value='$[PDF options]' />");
    SDV($WikipublisherTargetFmt, '_blank');
    SDV($WikipublisherUrlFmt,'http://www.wikipublisher.org/cgi-bin/mkpdf.pl');
} else SDV($PDFTypesetFmt, " <input type='submit' value='$[Publish]' />");
if ($action=='browse') {
    $HTMLStylesFmt['pdf'] = "
form.pdf2you { float: right; margin-left:8px; }
#wikitext a.pdf2you:hover { border-bottom-style: none; }";
    SDV($PageTypesetFmt,"<form 
    class='pdf2you' action='\$ScriptUrl' method='get'><input 
    type='hidden' name='n' value='\$FullName' /><input
    type='hidden' name='action' value='texprint' /><a class='pdf2you' 
    href='\$PageUrl?action=print&ptype=print&format=makepdf'><img align='absmiddle'  
    src='\$FarmPubDirUrl/images/pdficon.gif' title='Typeset page' /></a> <input
    class='pubbutton' type='submit' value='$[options]' /></form>\n");
/*
    $HTMLStylesFmt['pdf'] = "
p.pdf2you { float: right; margin-left:8px; }";
    SDV($PageTypesetFmt,"<p class='pdf2you'>
    <a href='\$PageUrl?action=print&ptype=print&format=makepdf'><img 
    src='\$FarmPubDirUrl/images/pdficon.gif' title='Typeset page as PDF' /></a>
    <sup>(<a href='\$PageUrl?action=texprint'>$[options]</a>)</sup></p>\n");
*/
    SDV($HandleBrowseFmt,array(&$PageStartFmt,
    &$PageTypesetFmt,&$PageRedirectFmt,'$PageText',&$PageEndFmt));
} elseif ($action=='texerror') {
	$MarkupEnabled['mailform'] = 1;
        Markup('wikipublisherr', '>links',
          '/\\(:wikipublishererror(\\s.*?)?:\\)/e',
          "WikipublisherErrorBox(\$pagename, ParseArgs(PSS('$1')))");
        SDV($HandleActions['texerror'], 'HandleWikipublisherError');
        if (isset($_GET['support'])) {
            SDV($WPSupportAddress, $_GET['support']);
            unset($_GET['support']);
        }
} elseif ($action=='mailform') { 
	$MarkupEnabled['mailform'] = 1;
	SDV($MailFormAddresses['support'], 'donald@mcs.vuw.ac.nz');
} elseif ($format == 'makepdf' && !isset($_GET['pdfoptions']))  {
        if ($_REQUEST['cancel']) { Redirect($pagename); exit; }
        $_GET['format'] = 'pdf';
        Markup('wikipublisher', '>links',
          '/\\(:wikipublisher(\\s.*?)?:\\)/e',
          "WikipublisherBox(\$pagename, ParseArgs(PSS('$1')))");
        $action = 'wikipublisher';
        SDV($HandleActions['wikipublisher'], 'HandleWikipublisherRequest');
}

## WikipublisherCancel inserts a Cancel form and button
function WikipublisherCancel($pagename, $opt) {
  return FmtPageName("<form 
    class='publish' action='\$ScriptUrl' method='get'><input 
    type='hidden' name='n' value='\$FullName' /><input
    type='hidden' name='action' value='browse' /><input
    class='pubbutton' type='submit' 
    value=\"{$opt['cancel']}\" /></form>", $pagename);
}

## WikipublisherBox generates the output of the (:wikipublisher:) markup.
## If $WikipublisherBoxFmt is defined, that is used, otherwise a form
## is generated.  Options include email=, size=, wait=, cancel=.
function WikipublisherBox($pagename, $opt) {
  global $WikipublisherBoxFmt,$EnablePDFDebug,$WPVersionNum,$EnableLatex,
    $EnablePDFVerify;
  if (isset($WikipublisherBoxFmt)) 
      return FmtPageName($WikipublisherBoxFmt, $pagename);
  SDVA($WikipublisherBoxOpt, array('size' => '30', 
    'email' => FmtPageName('$[Email]', $pagename),
    'wait'  => FmtPageName('$[Download]', $pagename),
    'latex' => FmtPageName('$[(LaTeX)]', $pagename),
    'debug' => FmtPageName('$[(debug)]', $pagename),
    'cancel' => FmtPageName('$[Back to page]', $pagename)
    ));
  $opt = array_merge($WikipublisherBoxOpt, (array)$opt);
  $out[] = FmtPageName("<form class='publish' target='\$WikipublisherTargetFmt'
    action='\$WikipublisherUrlFmt/\$ScriptUrl' method='get'>", 
    $pagename);

  SDV($_GET['n'], FmtPageName('$FullName',$pagename));
  foreach($_GET as $name => $value) {
    if (is_array($value))
      for ($i=0;$i<count($value);$i++)
        $out[] = '<input type="hidden" name="' . htmlspecialchars($name) .
	'[]" value="' . htmlspecialchars($value[$i]) . '" />';
    elseif ($value != '') 
      $out[] = '<input type="hidden" name="' . htmlspecialchars($name) .
	'" value="' . preg_replace('/\x91/','&lsquo;', 
            preg_replace('/\x92/','&rsquo;',
            htmlspecialchars($value,ENT_QUOTES))) . '" />';
  }

# pass authentication to wikipublisher
  if (isset($_COOKIE['PHPSESSID']))
      $out[] =  '<input type="hidden" name="PHPSESSID" '.
      'value="'.htmlspecialchars($_COOKIE['PHPSESSID'],ENT_QUOTES) . '" />';
  $out[] = "<input type='hidden' name='wpversion' value='$WPVersionNum' />";

  $out[] = "<input type='text' name='email' value='' 
    size='{$opt['size']}' /> <input class='pubbutton' name='submitemail' 
    type='submit' value=\"{$opt['email']}\" /><br />";

  $out[] = "<input class='pubbutton' type='submit' 
    value=\"{$opt['wait']}\" />";
# format optional buttons
  foreach (array('latex' => 'EnableLatex', 'debug' => 'EnablePDFDebug',
    'verify' => 'EnablePDFVerify') as $k => $v) {
      SDV($$v,false);
      if ($$v) $out[] = " <input class='pubbutton' type='submit' name='" . 
    strtoupper($k) . "' value=\"{$opt[$k]}\" />";
  }

  $out[] = '</form>'.WikipublisherCancel($pagename, array('cancel' => $opt['cancel']));
  return implode('', $out);
}

## WikipublisherErrorBox generates the output of the (:wikipublisherr:) markup.
## If $WikipublisherErrorBoxFmt is defined, that is used, otherwise a form
## is generated.  Options include address=, label=, subject=, cancel=.
function WikipublisherErrorBox($pagename, $opt) {
  global $WPErrorBoxFmt, $WPSupportAddress, $WPVersion, $MailFormFmt;
  if (isset($WPErrorBoxFmt)) 
      return FmtPageName($WPErrorBoxFmt, $pagename);
  SDVA($WPErrorBoxOpt, array(
    'address' => ($WPSupportAddress) ? $WPSupportAddress : 'support',
    'subject' => FmtPageName('$[Wikipublisher error report]', $pagename),
    'label'   => FmtPageName('$[Email wikipublisher support]', $pagename),
    'redirect'=> 'texerror',
    'cancel'  => FmtPageName('$[Back to page]', $pagename)
    ));
  $opt = array_merge($WPErrorBoxOpt, (array)$opt);
  $body[] = FmtpageName('url: $PageUrl', $pagename);
  foreach($_GET as $name => $value) {
    if (is_array($value))
      for ($i=0;$i<count($value);$i++)
        $body[] = htmlspecialchars($name) . '[]: ' . 
            htmlspecialchars($value[$i]);
    elseif ($value != '') 
      $body[] = htmlspecialchars($name) . ': ' . 
            preg_replace('/\x91/','&lsquo;', preg_replace('/\x92/','&rsquo;',
            htmlspecialchars($value,ENT_QUOTES)));
  }
  $opt['message'] = ($_GET['mailform']) ? '' : implode("\n",$body);
  $out[] = MakeMailForm($pagename, $opt, $MailFormFmt);
  $out[] = WikipublisherCancel($pagename, array('cancel' => $opt['cancel']));
  return implode('', $out);
}

function HandleWikipublisher($pagename, $auth, $pg) {
  global $HandleWikipublisherFmt, $PageStartFmt, $PageEndFmt, $FmtP,
       $WikipublisherPage;
  SDVA($WikipublisherPage, array(
      'request' => 'Site.Wikipublisher',
      'error'   => 'Site.WikipublisherError'));
  PCache($pagename,RetrieveAuthPage($pagename,$auth,true,READPAGE_CURRENT));
  $FmtP['/\\$LastModified/e'] = '$GLOBALS[\'CurrentTime\']';
  SDV($HandleWikipublisherFmt,
      array(&$PageStartFmt, 'wiki:' . $WikipublisherPage[$pg], &$PageEndFmt));
  PrintFmt($pagename,$HandleWikipublisherFmt);
}

function HandleWikipublisherRequest($pagename, $auth='read') {
  HandleWikipublisher($pagename, $auth, 'request');
}

function HandleWikipublisherError($pagename, $auth='read') {
  HandleWikipublisher($pagename, $auth, 'error');
}

?>